// Logic OR component for the LogicSimulator
// Copyright (C) 2022 Sascha Nitsch

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// eslint-disable-next-line @typescript-eslint/no-unused-vars
function LogicOrInit() {
  class LogicOr extends LogicBase {
    constructor(simulator: Simulator, id: string, param: BaseComponentParam) {
      super(simulator, id, param);
    }
    setup(canvas: SVGElement) {
      super.doSetup('logicor', canvas);
    }
    update(): boolean {
      if (this.startdelay) {
        --this.startdelay;
        return false;
      }
      const oldstate = this.q;
      this.q = this.a || this.b;
      this.getPin('q').setBool(this.q);
      return oldstate !== this.q;
    }
  }
  window.LogicOr = LogicOr;
}

// eslint-disable-next-line @typescript-eslint/no-unused-vars
function LogicOrDepends() {
  return 'LogicBase';
}
