// Power component for the LogicSimulator
// Copyright (C) 2022 Sascha Nitsch

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// eslint-disable-next-line @typescript-eslint/no-unused-vars
class Power extends BaseComponent {
  constructor(simulator: Simulator, id: string) {
    super(simulator, id);
    this.pins.set('q', new TriState(this, 0, 0, WireState.high, { id: 'power' }));
  }

  setup(canvas: SVGElement) {
    super.doSetup('power', canvas);
  }
}
